//
// BuiltIn.h
//
// $Id: //poco/1.4/CppParser/include/Poco/CppParser/BuiltIn.h#1 $
//
// Library: CppParser
// Package: SymbolTable
// Module:  BuiltIn
//
// Definition of the BuiltIn class.
//
// Copyright (c) 2011, Applied Informatics Software Engineering GmbH.
// and Contributors.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//


#ifndef CppParser_BuiltIn_INCLUDED
#define CppParser_BuiltIn_INCLUDED


#include "Poco/CppParser/CppParser.h"
#include "Poco/CppParser/Symbol.h"


namespace Poco {
namespace CppParser {


class CppParser_API BuiltIn: public Symbol
	/// A placeholder for a built-in type.
{
public:
	BuiltIn(const std::string& name, NameSpace* pNameSpace);
		/// Creates the BuiltIn.

	~BuiltIn();
		/// Destroys the BuiltIn.

	Symbol::Kind kind() const;
	std::string toString() const;
};


} } // namespace Poco::CppParser


#endif // CppParser_BuiltIn_INCLUDED
